from functools import cache


@cache
def isinc(tup):
    for cur, nex in zip(tup, tup[1:]):
        if nex <= cur:
    # for i in range(len(tup)-1):
    #     if tup[i+1] <= tup[i]:
            return False
    return True


@cache
def isdec(tup):
    for cur, nex in zip(tup, tup[1:]):
        if nex >= cur:
    # for i in range(len(tup)-1):
    #     if tup[i+1] >= tup[i]:
            return False
    return True


@cache
def isbitonic(tup):
    tupsetlen = len({*tup})
    tuplen = len(tup)
    if tuplen == 1 or tuplen == 2 and tupsetlen == 2:
        return True
    elif tuplen == 2 and tupsetlen == 1:
        return False
    tupmax = max(tup)
    if tup.count(tupmax) > 1:
        return False
    i = tup.index(tupmax)
    bef = *tup[:i],
    aft = *tup[i+1:],
    # return len({*bef}) == len(bef) and len({*aft}) == len(aft) and bef == sorted(bef) and aft == sorted(aft, reverse=True)
    return isinc(bef) and isdec(aft)
    #
    # if isinc(lst[:i]) and isdec(lst[i+1:]):
    #     return True
    # return False


n = int(input())
a_s = *map(int, input().split()),
aslen = len(a_s)
# res = 0
# for i in range(aslen):
#     for j in range(i, aslen):
#         res += isbitonic(a_s[i:j+1])
# print(res)
print(sum(sum(isbitonic(a_s[i:j+1]) for j in range(i, aslen)) for i in range(aslen)))