from itertools import count
from math import log
from sys import exit

def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**.5) + 1):
        if not num % i:
            return False
    return True


def prime_factors(num):
    factors = []
    for i in count(2):
        q, r = divmod(num, i)
        if not r:
            factors.append(q)
            num = q
        if num <= 1:
            break
    return factors


n = int(input())
*a, = map(int, input().split())
if n == 1:
    print(1)
    exit()
a_clr = [1] * n
if {*a} == {1}:
    print(*a_clr)
    exit()
fst = set()
a_min = min(i for i in a if i != 1)
while (a_min := (a_min ** .5)).is_integer():
    pass
a_min = round(a_min ** 2)
if all(i <= 4 for i in a):  # 1, 3 and 4 subtasks
    print(*(1 if i in {1, 4} else 2 for i in a))
elif all(round(log(i, a_min), 9).is_integer() for i in a):
    print(*(round(log(i, a_min)) % 2 + 1 for i in a))
else:
    for idx, (i, i_clr) in enumerate(zip(a, a_clr)):
        if a_clr[idx] == 2:
            continue
        if any(not i % f and is_prime(i // f) for f in fst):
            a_clr[idx] = 2
        else:
            fst.add(i)
    print(*a_clr)
